#include "stdafx.h"
#include "tinyxml2/tinyxml2.h"
#include "LuaCfgHelper.h"
#include <iostream>
#include <boost/algorithm/string.hpp>
#include "M_ActivitySummerPlanRedpacketCFG.h"
std::auto_ptr<M_ActivitySummerPlanRedpacketCFG> M_ActivitySummerPlanRedpacketCFG::msSingleton(nullptr);

int M_ActivitySummerPlanRedpacketCFG::GetCount()
{
	return (int)mMapData.size();
}

const M_ActivitySummerPlanRedpacketCFGData* M_ActivitySummerPlanRedpacketCFG::GetData(int ID)
{
	auto it = mMapData.find(ID);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

const std::map<int, M_ActivitySummerPlanRedpacketCFGData>& M_ActivitySummerPlanRedpacketCFG::GetMapData()
{
	return mMapData;
}

void M_ActivitySummerPlanRedpacketCFG::Load()
{
	tinyxml2::XMLDocument xmlDoc;
	std::string content = FileUtils::getInstance()->getStringFromFile("Config/M_ActivitySummerPlanRedpacketCFG.xml");
	auto result = xmlDoc.Parse(content.c_str(), content.length());
	if (result != tinyxml2::XML_SUCCESS)
	{
		CCLOGERROR("Result:%d", result);
		CCASSERT(false, "result != tinyxml2::XML_SUCCESS");
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		CCASSERT(false, "root == NULL");
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		M_ActivitySummerPlanRedpacketCFGData data;
		data.mID = element->IntAttribute("ID");
		data.mNeedType = element->IntAttribute("NeedType");
		data.mNeedCount = element->IntAttribute("NeedCount");
		data.mItemID = element->IntAttribute("ItemID");
		data.mItemCount = element->IntAttribute("ItemCount");
		{
			const char* ItemProbability = element->Attribute("ItemProbability");
			std::vector<std::string> vecItemProbability;
			boost::split(vecItemProbability, ItemProbability, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecItemProbability.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecItemProbability[i].c_str(), &temp))
				{
					data.mItemProbability.push_back(temp);
				}
			}
		}
		data.mShowName = element->Attribute("ShowName");
		data.mRewardTitle = element->Attribute("RewardTitle");
		data.mNeedActive = element->IntAttribute("NeedActive");
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		element = element->NextSiblingElement();
	}
	CCLOG("M_ActivitySummerPlanRedpacketCFG Loaded. Load Data:%u", mMapData.size());
}

void M_ActivitySummerPlanRedpacketCFG::LoadLua()
{
	LuaEngine::getInstance()->executeScriptFile("config/M_ActivitySummerPlanRedpacketCFG");
	lua_State* L = LuaEngine::getInstance()->getLuaStack()->getLuaState();
	lua_getglobal(L, "M_ActivitySummerPlanRedpacketCFG");
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushstring(L, "datas");
	lua_gettable(L, -2);
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushnil(L);
	while(lua_next(L, 2))
	{
		CCASSERT(lua_istable(L, -1) == 1, "is not table");
		M_ActivitySummerPlanRedpacketCFGData data;
		LuaCfgHelper::readInt(L, "ID", data.mID);
		LuaCfgHelper::readInt(L, "NeedType", data.mNeedType);
		LuaCfgHelper::readInt(L, "NeedCount", data.mNeedCount);
		LuaCfgHelper::readInt(L, "ItemID", data.mItemID);
		LuaCfgHelper::readInt(L, "ItemCount", data.mItemCount);
		LuaCfgHelper::readVectorInt(L, "ItemProbability", data.mItemProbability);
		LuaCfgHelper::readString(L, "ShowName", data.mShowName);
		LuaCfgHelper::readString(L, "RewardTitle", data.mRewardTitle);
		LuaCfgHelper::readInt(L, "NeedActive", data.mNeedActive);
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		lua_pop(L, 1);
	}
	lua_settop(L, 0);
	CCLOG("M_ActivitySummerPlanRedpacketCFG Loaded. Load Data:%u", mMapData.size());
}

void M_ActivitySummerPlanRedpacketCFG::Reload()
{
	mMapData.clear();
	Load();
}

M_ActivitySummerPlanRedpacketCFG* M_ActivitySummerPlanRedpacketCFG::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new M_ActivitySummerPlanRedpacketCFG());
	}
	return msSingleton.get();
}

void M_ActivitySummerPlanRedpacketCFG::Release()
{
	msSingleton.reset(nullptr);
}
